diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-spectrum-value-helper.h ns-3.42/src/wifi/model/wifi-spectrum-value-helper.h
--- ns-3.41/src/wifi/model/wifi-spectrum-value-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/wifi/model/wifi-spectrum-value-helper.h	2024-05-29 15:29:47.216073800 -0700
@@ -0,0 +1,394 @@
+/*
+ * Copyright (c) 2009 CTTC
+ * Copyright (c) 2017 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Nicola Baldo <nbaldo@cttc.es>
+ *          Rediet <getachew.redieteab@orange.com>
+ */
+
+#ifndef WIFI_SPECTRUM_VALUE_HELPER_H
+#define WIFI_SPECTRUM_VALUE_HELPER_H
+
+#include <ns3/spectrum-value.h>
+
+namespace ns3
+{
+
+/**
+ * typedef for a pair of start and stop sub-band indices
+ */
+using WifiSpectrumBandIndices = std::pair<uint32_t, uint32_t>;
+
+/**
+ * \ingroup spectrum
+ *
+ *  This class defines all functions to create a spectrum model for
+ *  Wi-Fi based on a a spectral model aligned with an OFDM subcarrier
+ *  spacing of 312.5 KHz (model also reused for DSSS modulations)
+ */
+class WifiSpectrumValueHelper
+{
+  public:
+    /**
+     * Destructor
+     */
+    virtual ~WifiSpectrumValueHelper() = default;
+
+    /**
+     * Return a SpectrumModel instance corresponding to the center frequency
+     * and channel width.  The spectrum model spans the channel width
+     * +/- the guard bands (i.e. the model will span (channelWidth +
+     * 2 * guardBandwidth) MHz of bandwidth).
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param carrierSpacing carrier spacing (Hz)
+     * \param guardBandwidth width of the guard band (MHz)
+     *
+     * \return the static SpectrumModel instance corresponding to the
+     * given carrier frequency and channel width configuration.
+     */
+    static Ptr<SpectrumModel> GetSpectrumModel(uint32_t centerFrequency,
+                                               uint16_t channelWidth,
+                                               uint32_t carrierSpacing,
+                                               uint16_t guardBandwidth);
+
+    /**
+     * Create a transmit power spectral density corresponding to DSSS
+     *
+     * The center frequency typically corresponds to 802.11b channel
+     * center frequencies but is not restricted to those frequencies.
+     *
+     * \note There is no channel width parameter; this method assumes 22 MHz
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param txPowerW  transmit power (W) to allocate
+     * \param guardBandwidth width of the guard band (MHz)
+     * \returns a pointer to a newly allocated SpectrumValue representing the DSSS Transmit Power
+     * Spectral Density in W/Hz
+     */
+    static Ptr<SpectrumValue> CreateDsssTxPowerSpectralDensity(uint32_t centerFrequency,
+                                                               double txPowerW,
+                                                               uint16_t guardBandwidth);
+
+    /**
+     * Create a transmit power spectral density corresponding to OFDM
+     * (802.11a/g).  Channel width may vary between 20, 10, and 5 MHz.
+     * Guard bandwidth also typically varies with channel width.
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param txPowerW  transmit power (W) to allocate
+     * \param guardBandwidth width of the guard band (MHz)
+     * \param minInnerBandDbr the minimum relative power in the inner band (in dBr)
+     * \param minOuterbandDbr the minimum relative power in the outer band (in dBr)
+     * \param lowestPointDbr maximum relative power of the outermost subcarriers of the guard band
+     * (in dBr)
+     * \return a pointer to a newly allocated SpectrumValue representing the OFDM Transmit Power
+     * Spectral Density in W/Hz for each Band
+     */
+    static Ptr<SpectrumValue> CreateOfdmTxPowerSpectralDensity(uint32_t centerFrequency,
+                                                               uint16_t channelWidth,
+                                                               double txPowerW,
+                                                               uint16_t guardBandwidth,
+                                                               double minInnerBandDbr = -20,
+                                                               double minOuterbandDbr = -28,
+                                                               double lowestPointDbr = -40);
+
+    /**
+     * Create a transmit power spectral density corresponding to OFDM duplicated over multiple 20
+     * MHz subchannels. Channel width may vary between 20, 40, 80, and 160 MHz.
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param txPowerW  transmit power (W) to allocate
+     * \param guardBandwidth width of the guard band (MHz)
+     * \param minInnerBandDbr the minimum relative power in the inner band (in dBr)
+     * \param minOuterbandDbr the minimum relative power in the outer band (in dBr)
+     * \param lowestPointDbr maximum relative power of the outermost subcarriers of the guard band
+     * (in dBr)
+     * \param puncturedSubchannels bitmap indicating whether a 20 MHz subchannel is punctured or not
+     * \return a pointer to a newly allocated SpectrumValue representing the duplicated 20 MHz OFDM
+     * Transmit Power Spectral Density in W/Hz for each Band
+     */
+    static Ptr<SpectrumValue> CreateDuplicated20MhzTxPowerSpectralDensity(
+        uint32_t centerFrequency,
+        uint16_t channelWidth,
+        double txPowerW,
+        uint16_t guardBandwidth,
+        double minInnerBandDbr = -20,
+        double minOuterbandDbr = -28,
+        double lowestPointDbr = -40,
+        const std::vector<bool>& puncturedSubchannels = std::vector<bool>{});
+
+    /**
+     * Create a transmit power spectral density corresponding to OFDM
+     * High Throughput (HT) (802.11n/ac).  Channel width may vary between
+     * 20, 40, 80, and 160 MHz.
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param txPowerW  transmit power (W) to allocate
+     * \param guardBandwidth width of the guard band (MHz)
+     * \param minInnerBandDbr the minimum relative power in the inner band (in dBr)
+     * \param minOuterbandDbr the minimum relative power in the outer band (in dBr)
+     * \param lowestPointDbr maximum relative power of the outermost subcarriers of the guard band
+     * (in dBr)
+     * \return a pointer to a newly allocated SpectrumValue representing the HT OFDM Transmit Power
+     * Spectral Density in W/Hz for each Band
+     */
+    static Ptr<SpectrumValue> CreateHtOfdmTxPowerSpectralDensity(uint32_t centerFrequency,
+                                                                 uint16_t channelWidth,
+                                                                 double txPowerW,
+                                                                 uint16_t guardBandwidth,
+                                                                 double minInnerBandDbr = -20,
+                                                                 double minOuterbandDbr = -28,
+                                                                 double lowestPointDbr = -40);
+
+    /**
+     * Create a transmit power spectral density corresponding to OFDM
+     * High Efficiency (HE) (802.11ax).  Channel width may vary between
+     * 20, 40, 80, and 160 MHz.
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param txPowerW  transmit power (W) to allocate
+     * \param guardBandwidth width of the guard band (MHz)
+     * \param minInnerBandDbr the minimum relative power in the inner band (in dBr)
+     * \param minOuterbandDbr the minimum relative power in the outer band (in dBr)
+     * \param lowestPointDbr maximum relative power of the outermost subcarriers of the guard band
+     * (in dBr)
+     * \param puncturedSubchannels bitmap indicating whether a 20 MHz subchannel is punctured or not
+     * \return a pointer to a newly allocated SpectrumValue representing the HE OFDM Transmit Power
+     * Spectral Density in W/Hz for each Band
+     */
+    static Ptr<SpectrumValue> CreateHeOfdmTxPowerSpectralDensity(
+        uint32_t centerFrequency,
+        uint16_t channelWidth,
+        double txPowerW,
+        uint16_t guardBandwidth,
+        double minInnerBandDbr = -20,
+        double minOuterbandDbr = -28,
+        double lowestPointDbr = -40,
+        const std::vector<bool>& puncturedSubchannels = std::vector<bool>{});
+
+    /**
+     * Create a transmit power spectral density corresponding to the OFDMA part
+     * of HE TB PPDUs for a given RU.
+     * An ideal (i.e. rectangular) spectral mask is considered for the time being.
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param txPowerW  transmit power (W) to allocate
+     * \param guardBandwidth width of the guard band (MHz)
+     * \param ru the RU band used by the STA
+     * \return a pointer to a newly allocated SpectrumValue representing the HE OFDM Transmit Power
+     * Spectral Density on the RU used by the STA in W/Hz for each Band
+     */
+    static Ptr<SpectrumValue> CreateHeMuOfdmTxPowerSpectralDensity(
+        uint32_t centerFrequency,
+        uint16_t channelWidth,
+        double txPowerW,
+        uint16_t guardBandwidth,
+        const WifiSpectrumBandIndices& ru);
+
+    /**
+     * Create a power spectral density corresponding to the noise
+     *
+     * \param centerFrequency center frequency (MHz)
+     * \param channelWidth channel width (MHz)
+     * \param carrierSpacing carrier spacing (Hz)
+     * \param noiseFigure the noise figure in dB w.r.t. a reference temperature of 290K
+     * \param guardBandwidth width of the guard band (MHz)
+     * \return a pointer to a newly allocated SpectrumValue representing the noise Power Spectral
+     * Density in W/Hz for each Band
+     */
+    static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity(uint32_t centerFrequency,
+                                                              uint16_t channelWidth,
+                                                              uint32_t carrierSpacing,
+                                                              double noiseFigure,
+                                                              uint16_t guardBandwidth);
+
+    /**
+     * Create a thermal noise power spectral density
+     *
+     * \param noiseFigure the noise figure
+     * \param spectrumModel the spectrum model
+     * \return a pointer to a newly allocated SpectrumValue representing the noise Power Spectral
+     * Density in W/Hz corresponding to thermal noise, for each Band
+     */
+    static Ptr<SpectrumValue> CreateNoisePowerSpectralDensity(double noiseFigure,
+                                                              Ptr<SpectrumModel> spectrumModel);
+
+    /**
+     * Create a transmit power spectral density corresponding to OFDM
+     * transmit spectrum mask requirements for 11a/11g/11n/11ac/11ax
+     * Channel width may vary between 5, 10, 20, 40, 80, and 160 MHz.
+     * The default (standard) values are illustrated below.
+     *
+     *   [ guard band  ][    channel width     ][  guard band ]
+     *                   __________   __________                  _ 0 dBr
+     *                  /          | |          \
+     *                 /           |_|           \                _ -20 dBr
+     *             . '                             ' .
+     *         . '                                     ' .        _ -28 dBr
+     *       .'                                           '.
+     *     .'                                               '.
+     *   .'                                                   '.  _ lowest point
+     *
+     *   |-----|                                         |-----|  outerBand left/right
+     *         |------|                           |-- ---|        middle band left/right
+     *                |-|                       |-|               inner band left/right
+     *                  |-----------------------|                 allocated sub-bands
+     *   |-----------------------------------------------------|  mask band
+     *
+     * Please take note that, since guard tones are within the allocated band
+     * while not being ideally allocated any power, the inner band had to be
+     * shifted inwards and a flat junction band (at -20 dBr) had to be added
+     * between the inner and the middle bands.
+     *
+     * \param c spectrumValue to allocate according to transmit power spectral density mask (in W/Hz
+     * for each band)
+     * \param allocatedSubBands vector of start and stop subcarrier indexes of the allocated sub
+     * bands
+     * \param maskBand start and stop subcarrier indexes of transmit mask (in case signal doesn't
+     * cover whole SpectrumModel)
+     * \param txPowerPerBandW power allocated to each subcarrier in the allocated sub bands
+     * \param nGuardBands size (in number of subcarriers) of the guard band (left and right)
+     * \param innerSlopeWidth size (in number of subcarriers) of the inner band (i.e. slope going
+     * from 0 dBr to -20 dBr in the figure above)
+     * \param minInnerBandDbr the minimum relative power in the inner band (i.e., -20 dBr in the
+     * figure above)
+     * \param minOuterbandDbr the minimum relative power in the outer band (i.e., -28 dBr in the
+     * figure above)
+     * \param lowestPointDbr maximum relative power of the outermost subcarriers of the guard band
+     * (in dBr)
+     * \param puncturedSubBands vector of start and stop subcarrier indexes of the punctured sub
+     * bands
+     * \param puncturedSlopeWidth size (in number of subcarriers) of the punctured band slope
+     */
+    static void CreateSpectrumMaskForOfdm(
+        Ptr<SpectrumValue> c,
+        const std::vector<WifiSpectrumBandIndices>& allocatedSubBands,
+        const WifiSpectrumBandIndices& maskBand,
+        double txPowerPerBandW,
+        uint32_t nGuardBands,
+        uint32_t innerSlopeWidth,
+        double minInnerBandDbr,
+        double minOuterbandDbr,
+        double lowestPointDbr,
+        const std::vector<WifiSpectrumBandIndices>& puncturedSubBands =
+            std::vector<WifiSpectrumBandIndices>{},
+        uint32_t puncturedSlopeWidth = 0);
+
+    /**
+     * Normalize the transmit spectrum mask generated by CreateSpectrumMaskForOfdm
+     * so that the total transmitted power corresponds to the input value.
+     *
+     * \param c spectrumValue to normalize (in W/Hz for each band)
+     * \param txPowerW total transmit power (W) to allocate
+     */
+    static void NormalizeSpectrumMask(Ptr<SpectrumValue> c, double txPowerW);
+
+    /**
+     * Convert from dBm to Watts.
+     * Taken from wifi-utils since the original method couldn't be called from here
+     * due to resulting circular dependencies of spectrum and wifi modules.
+     *
+     * \param dbm the power in dBm
+     *
+     * \return the equivalent Watts for the given dBm
+     */
+    static double DbmToW(double dbm);
+
+    /**
+     * Calculate the power of the specified band composed of uniformly-sized sub-bands.
+     *
+     * \param psd received Power Spectral Density in W/Hz
+     * \param band a pair of start and stop indexes that defines the band
+     *
+     * \return band power in W
+     */
+    static double GetBandPowerW(Ptr<SpectrumValue> psd, const WifiSpectrumBandIndices& band);
+};
+
+/**
+ * \ingroup spectrum
+ * Struct defining a frequency range between minFrequency (MHz) and maxFrequency (MHz).
+ */
+struct FrequencyRange
+{
+    uint16_t minFrequency{0}; ///< the minimum frequency in MHz
+    uint16_t maxFrequency{0}; ///< the maximum frequency in MHz
+};
+
+/**
+ * Compare two FrequencyRange values
+ *
+ * \param lhs the FrequencyRange value on the left of operator
+ * \param rhs the FrequencyRange value on the right of operator
+ *
+ * \return true if minFrequency of left is less than minFrequency of right, false otherwise
+ */
+bool operator<(const FrequencyRange& lhs, const FrequencyRange& rhs);
+
+/**
+ * Compare two FrequencyRange values
+ *
+ * \param lhs the FrequencyRange value on the left of operator
+ * \param rhs the FrequencyRange value on the right of operator
+ *
+ * \return true if both minFrequency and maxFrequency of left are equal to minFrequency and
+ * maxFrequency of right respectively, false otherwise
+ */
+bool operator==(const FrequencyRange& lhs, const FrequencyRange& rhs);
+
+/**
+ * Compare two FrequencyRange values
+ *
+ * \param lhs the FrequencyRange value on the left of operator
+ * \param rhs the FrequencyRange value on the right of operator
+ *
+ * \return true if either minFrequency or maxFrequency of left different from minFrequency or
+ * maxFrequency of right respectively, false otherwise
+ */
+bool operator!=(const FrequencyRange& lhs, const FrequencyRange& rhs);
+
+/**
+ * Serialize FrequencyRange values to ostream (human-readable).
+ *
+ * \param os the output stream
+ * \param freqRange the FrequencyRange
+ *
+ * \return std::ostream
+ */
+std::ostream& operator<<(std::ostream& os, const FrequencyRange& freqRange);
+
+/// Identifier for the frequency range covering the whole wifi spectrum
+constexpr FrequencyRange WHOLE_WIFI_SPECTRUM = {2401, 7125};
+
+/// Identifier for the frequency range covering the wifi spectrum in the 2.4 GHz band
+constexpr FrequencyRange WIFI_SPECTRUM_2_4_GHZ = {2401, 2483};
+
+/// Identifier for the frequency range covering the wifi spectrum in the 5 GHz band
+constexpr FrequencyRange WIFI_SPECTRUM_5_GHZ = {5170, 5915};
+
+/// Identifier for the frequency range covering the wifi spectrum in the 6 GHz band
+constexpr FrequencyRange WIFI_SPECTRUM_6_GHZ = {5945, 7125};
+
+} // namespace ns3
+
+#endif /*  WIFI_SPECTRUM_VALUE_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-standards.cc ns-3.42/src/wifi/model/wifi-standards.cc
--- ns-3.41/src/wifi/model/wifi-standards.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/wifi/model/wifi-standards.cc	2024-05-29 15:29:47.216073800 -0700
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#include "wifi-standards.h"
+
+namespace ns3
+{
+
+const std::map<WifiStandard, std::list<WifiPhyBand>> wifiStandards = {
+    {WIFI_STANDARD_80211a, {WIFI_PHY_BAND_5GHZ}},
+    {WIFI_STANDARD_80211b, {WIFI_PHY_BAND_2_4GHZ}},
+    {WIFI_STANDARD_80211g, {WIFI_PHY_BAND_2_4GHZ}},
+    {WIFI_STANDARD_80211p, {WIFI_PHY_BAND_5GHZ}},
+    {WIFI_STANDARD_80211n, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ}},
+    {WIFI_STANDARD_80211ac, {WIFI_PHY_BAND_5GHZ}},
+    {WIFI_STANDARD_80211ad, {WIFI_PHY_BAND_60GHZ}},
+    {WIFI_STANDARD_80211ax, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}},
+    {WIFI_STANDARD_80211be, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}},
+};
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-standards.h ns-3.42/src/wifi/model/wifi-standards.h
--- ns-3.41/src/wifi/model/wifi-standards.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-standards.h	2024-05-29 15:29:47.216073800 -0700
@@ -45,7 +45,8 @@
     WIFI_STANDARD_80211ac,
     WIFI_STANDARD_80211ad,
     WIFI_STANDARD_80211ax,
-    WIFI_STANDARD_80211be
+    WIFI_STANDARD_80211be,
+    WIFI_STANDARD_COUNT
 };
 
 /**
@@ -86,17 +87,7 @@
 /**
  * \brief map a given standard configured by the user to the allowed PHY bands
  */
-const std::map<WifiStandard, std::list<WifiPhyBand>> wifiStandards = {
-    {WIFI_STANDARD_80211a, {WIFI_PHY_BAND_5GHZ}},
-    {WIFI_STANDARD_80211b, {WIFI_PHY_BAND_2_4GHZ}},
-    {WIFI_STANDARD_80211g, {WIFI_PHY_BAND_2_4GHZ}},
-    {WIFI_STANDARD_80211p, {WIFI_PHY_BAND_5GHZ}},
-    {WIFI_STANDARD_80211n, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ}},
-    {WIFI_STANDARD_80211ac, {WIFI_PHY_BAND_5GHZ}},
-    {WIFI_STANDARD_80211ad, {WIFI_PHY_BAND_60GHZ}},
-    {WIFI_STANDARD_80211ax, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}},
-    {WIFI_STANDARD_80211be, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}},
-};
+extern const std::map<WifiStandard, std::list<WifiPhyBand>> wifiStandards;
 
 /**
  * \ingroup wifi
@@ -181,6 +172,39 @@
     }
 }
 
+/**
+ * Get the TypeId name for the FrameExchangeManager corresponding to the given standard.
+ *
+ * \param standard the given standard
+ * \param qosSupported whether QoS is supported (ignored if standard is at least HT)
+ * \return the TypeId name for the FrameExchangeManager corresponding to the given standard
+ */
+inline std::string
+GetFrameExchangeManagerTypeIdName(WifiStandard standard, bool qosSupported)
+{
+    if (standard >= WIFI_STANDARD_80211be)
+    {
+        return "ns3::EhtFrameExchangeManager";
+    }
+    if (standard >= WIFI_STANDARD_80211ax)
+    {
+        return "ns3::HeFrameExchangeManager";
+    }
+    if (standard >= WIFI_STANDARD_80211ac)
+    {
+        return "ns3::VhtFrameExchangeManager";
+    }
+    if (standard >= WIFI_STANDARD_80211n)
+    {
+        return "ns3::HtFrameExchangeManager";
+    }
+    if (qosSupported)
+    {
+        return "ns3::QosFrameExchangeManager";
+    }
+    return "ns3::FrameExchangeManager";
+}
+
 } // namespace ns3
 
 #endif /* WIFI_STANDARD_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-tx-parameters.cc ns-3.42/src/wifi/model/wifi-tx-parameters.cc
--- ns-3.41/src/wifi/model/wifi-tx-parameters.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-tx-parameters.cc	2024-05-29 15:29:47.216073800 -0700
@@ -75,7 +75,7 @@
     m_txVector = WifiTxVector();
     m_protection.reset(nullptr);
     m_acknowledgment.reset(nullptr);
-    m_txDuration = Time::Min();
+    m_txDuration.reset();
 }
 
 const WifiTxParameters::PsduInfo*
@@ -115,7 +115,13 @@
         }
 
         // Insert the info about the given frame
-        m_info.emplace(hdr.GetAddr1(), PsduInfo{hdr, mpdu->GetPacketSize(), 0, seqNumbers});
+        const auto [it, inserted] =
+            m_info.emplace(hdr.GetAddr1(), PsduInfo{hdr, mpdu->GetPacketSize(), 0, seqNumbers});
+        NS_ASSERT(inserted);
+
+        // store information to undo the addition of this MPDU
+        m_lastInfoIt = it;
+        m_undoInfo = PsduInfo{WifiMacHeader{}, 0, 0, {}};
         return;
     }
 
@@ -123,6 +129,16 @@
     NS_ASSERT_MSG((hdr.IsQosData() && !hdr.HasData()) || infoIt->second.amsduSize > 0,
                   "An MPDU can only be aggregated to an existing (A-)MPDU");
 
+    // store information to undo the addition of this MPDU
+    m_lastInfoIt = infoIt;
+    m_undoInfo =
+        PsduInfo{infoIt->second.header, infoIt->second.amsduSize, infoIt->second.ampduSize, {}};
+    if (hdr.IsQosData())
+    {
+        m_undoInfo.seqNumbers = {
+            {hdr.GetQosTid(), {hdr.GetSequenceNumber()}}}; // seq number to remove
+    }
+
     // The (A-)MSDU being built is included in an A-MPDU subframe
     infoIt->second.ampduSize = MpduAggregator::GetSizeIfAggregated(
         infoIt->second.header.GetSize() + infoIt->second.amsduSize + WIFI_MAC_FCS_LENGTH,
@@ -132,17 +148,59 @@
 
     if (hdr.IsQosData())
     {
-        auto ret = infoIt->second.seqNumbers.emplace(hdr.GetQosTid(),
-                                                     std::set<uint16_t>{hdr.GetSequenceNumber()});
+        const auto [it, inserted] =
+            infoIt->second.seqNumbers.emplace(hdr.GetQosTid(),
+                                              std::set<uint16_t>{hdr.GetSequenceNumber()});
 
-        if (!ret.second)
+        if (!inserted)
         {
             // insertion did not happen because an entry with the same TID already exists
-            ret.first->second.insert(hdr.GetSequenceNumber());
+            it->second.insert(hdr.GetSequenceNumber());
         }
     }
 }
 
+void
+WifiTxParameters::UndoAddMpdu()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT(m_lastInfoIt.has_value());
+
+    if (m_undoInfo.amsduSize == 0 && m_undoInfo.ampduSize == 0)
+    {
+        // the last MPDU was the first one being added for its receiver
+        m_info.erase(*m_lastInfoIt);
+        m_lastInfoIt.reset();
+        return;
+    }
+
+    auto& lastInfo = (*m_lastInfoIt)->second;
+    lastInfo.header = m_undoInfo.header;
+    lastInfo.amsduSize = m_undoInfo.amsduSize;
+    lastInfo.ampduSize = m_undoInfo.ampduSize;
+    // if the MPDU to remove is not a QoS data frame or it is the first QoS data frame added for
+    // a given receiver, no sequence number information is stored
+    if (!m_undoInfo.seqNumbers.empty())
+    {
+        NS_ASSERT(m_undoInfo.seqNumbers.size() == 1);
+        const auto tid = m_undoInfo.seqNumbers.cbegin()->first;
+        auto& seqNoSet = m_undoInfo.seqNumbers.cbegin()->second;
+        NS_ASSERT(seqNoSet.size() == 1);
+        NS_ASSERT(lastInfo.seqNumbers.contains(tid));
+        lastInfo.seqNumbers.at(tid).erase(*seqNoSet.cbegin());
+    }
+    m_lastInfoIt.reset();
+}
+
+bool
+WifiTxParameters::LastAddedIsFirstMpdu(Mac48Address receiver) const
+{
+    auto infoIt = m_info.find(receiver);
+    NS_ASSERT_MSG(infoIt != m_info.cend(), "No frame added for receiver " << receiver);
+    NS_ASSERT_MSG(m_lastInfoIt == infoIt, "Last MPDU not addressed to " << receiver);
+    return (m_undoInfo.amsduSize == 0 && m_undoInfo.ampduSize == 0);
+}
+
 uint32_t
 WifiTxParameters::GetSizeIfAddMpdu(Ptr<const WifiMpdu> mpdu) const
 {
@@ -178,11 +236,16 @@
     NS_ASSERT_MSG(infoIt != m_info.end(),
                   "There must be already an MPDU addressed to the same receiver");
 
-    infoIt->second.amsduSize = GetSizeIfAggregateMsdu(msdu).first;
+    // store information to undo the addition of this MSDU
+    m_lastInfoIt = infoIt;
+    m_undoInfo =
+        PsduInfo{infoIt->second.header, infoIt->second.amsduSize, infoIt->second.ampduSize, {}};
+
+    infoIt->second.amsduSize = GetSizeIfAggregateMsdu(msdu);
     infoIt->second.header.SetQosAmsdu();
 }
 
-std::pair<uint32_t, uint32_t>
+uint32_t
 WifiTxParameters::GetSizeIfAggregateMsdu(Ptr<const WifiMpdu> msdu) const
 {
     NS_LOG_FUNCTION(this << *msdu);
@@ -200,8 +263,7 @@
                   "The MPDU being built for this receiver must be a QoS data frame");
     NS_ASSERT_MSG(infoIt->second.header.GetQosTid() == msdu->GetHeader().GetQosTid(),
                   "The MPDU being built must belong to the same TID as the MSDU to aggregate");
-    NS_ASSERT_MSG(infoIt->second.seqNumbers.find(msdu->GetHeader().GetQosTid()) !=
-                      infoIt->second.seqNumbers.end(),
+    NS_ASSERT_MSG(infoIt->second.seqNumbers.contains(msdu->GetHeader().GetQosTid()),
                   "At least one MPDU with the same TID must have been added previously");
 
     // all checks passed
@@ -213,17 +275,7 @@
         currAmsduSize = MsduAggregator::GetSizeIfAggregated(currAmsduSize, 0);
     }
 
-    uint32_t newAmsduSize =
-        MsduAggregator::GetSizeIfAggregated(msdu->GetPacket()->GetSize(), currAmsduSize);
-    uint32_t newMpduSize = infoIt->second.header.GetSize() + newAmsduSize + WIFI_MAC_FCS_LENGTH;
-
-    if (infoIt->second.ampduSize > 0 || m_txVector.GetModulationClass() >= WIFI_MOD_CLASS_VHT)
-    {
-        return {newAmsduSize,
-                MpduAggregator::GetSizeIfAggregated(newMpduSize, infoIt->second.ampduSize)};
-    }
-
-    return {newAmsduSize, newMpduSize};
+    return MsduAggregator::GetSizeIfAggregated(msdu->GetPacket()->GetSize(), currAmsduSize);
 }
 
 uint32_t
